import 'package:bg_color/controller/home_controller.dart';
import 'package:flutter/material.dart';
import 'package:provider_mvc/controller.dart';
import 'package:provider_mvc/view.dart';

import '../view/slider_view.dart';

class HomeScreen extends View<HomeController> {
  final SliderView redSlider = SliderView(Colors.red);
  final SliderView greenSlider = SliderView(Colors.green);
  final SliderView blueSlider = SliderView(Colors.blue);

  HomeScreen()
      : super(controller: Controller.put<HomeController>(HomeController()));

  @override
  Widget builder(
      BuildContext context, HomeController controller, Widget widget) {
    return Scaffold(
      backgroundColor: Color.fromARGB(255, redSlider.controller.value,
          greenSlider.controller.value, blueSlider.controller.value),
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            redSlider,
            greenSlider,
            blueSlider,
          ],
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: () {
          redSlider.controller.value = 0;
          greenSlider.controller.value = 0;
          blueSlider.controller.value = 0;
          controller.refresh();
        },
        child: Icon(Icons.refresh),
      ),
    );
  }

  /*@override
  HomeController create(BuildContext context) =>
      Controller.put<HomeController>(HomeController());*/
}
