import 'package:flutter/material.dart';
import '../controller/slider_controller.dart';
import '../controller/home_controller.dart';
import 'package:provider_mvc/controller.dart';
import 'package:provider_mvc/view.dart';

class SliderView extends View<SliderController> {
  final Color _color;

  SliderView(this._color) : super(controller: SliderController());

  @override
  Widget builder(
      BuildContext context, SliderController controller, Widget widget) {
    return Slider(
      activeColor: _color,
      value: controller.value.toDouble(),
      min: 0,
      max: 255,
      divisions: 256,
      label: '${controller.value}',
      onChanged: (value) {
        controller.value = value.toInt();
        Controller.of<HomeController>().single.refresh();
      },
    );
  }

  /*@override
  SliderController create(BuildContext context) {
    String tag;

    if (_color == Colors.red) tag = 'RED';
    if (_color == Colors.green) tag = 'GREEN';
    if (_color == Colors.blue) tag = 'BLUE';

    if (tag == null) throw Exception('Only RED/GREEN/BLUE colors allowed!');

    return Controller.put<SliderController>(SliderController(tag));
  }*/
}
